SystemOrganization addCategory: #'Pier-JQuery-Widgets'!

PRStructuresWidget subclass: #PRAjaxSearchWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-JQuery-Widgets'!

!PRAjaxSearchWidget class methodsFor: 'accessing-defaults' stamp: 'lr 10/7/2010 15:36'!
defaultMaxItems
	^ 10! !

!PRAjaxSearchWidget class methodsFor: 'accessing-description' stamp: 'lr 9/12/2009 12:49'!
descriptionDropdownList
	^ nil! !

!PRAjaxSearchWidget class methodsFor: 'accessing-description' stamp: 'lr 10/7/2010 15:37'!
descriptionExampleText
	^ MAStringDescription new
		accessor: #exampleText;
		default: 'Search';
		label: 'Example';
		priority: 400;
		yourself! !

!PRAjaxSearchWidget class methodsFor: 'accessing-description' stamp: 'lr 10/7/2010 15:42'!
descriptionStructure
	^ PRStructureDescription new
		accessor: #structure;
		label: 'Search From';
		priority: 390;
		yourself! !

!PRAjaxSearchWidget class methodsFor: 'accessing' stamp: 'lr 9/12/2009 12:49'!
groupLabel
	^ 'Pier Search'! !

!PRAjaxSearchWidget class methodsFor: 'testing' stamp: 'lr 9/12/2009 12:49'!
isAbstract
	^ false! !

!PRAjaxSearchWidget class methodsFor: 'accessing' stamp: 'lr 10/7/2010 13:24'!
label
	^ 'Search Field (jQuery)'! !

!PRAjaxSearchWidget methodsFor: 'accessing' stamp: 'lr 9/12/2009 12:49'!
dropdownList
	^ false! !

!PRAjaxSearchWidget methodsFor: 'rendering' stamp: 'lr 10/7/2010 15:44'!
renderContentOn: html
	html textInput 
		exampleText: (self read: #descriptionExampleText);
		script: (html jQuery this autocomplete
			search: [ :value | self structuresFor: value ]
			labels: [ :value | value menu ]
			callback: [ :value :script |
				script goto: ((self context
					structure: value) 
					urlOn: html) ])! !

!PRAjaxSearchWidget methodsFor: 'private' stamp: 'lr 10/7/2010 15:43'!
structuresFor: aString
	| structure matches |
	structure := (self read: #descriptionStructure)
		ifNil: [ self context root ].
	matches := (structure fullTextSearch subString: aString)
		reject: [ :each | self isFiltered: each ].
	self maxItems isNil
		ifFalse: [ matches := matches first: (matches size min: self maxItems) ].
	^ matches sorted: [ :a :b | (self labelFor: a) <= (self labelFor: b) ]! !

!GRPackage class methodsFor: '*pier-jquery' stamp: 'lr 10/7/2010 17:01'!
pierJQuery
	^ self new
		name: 'Pier-JQuery';
		description: 'JQuery support for Pier';
		addDependency: 'Pier-Seaside';
		addDependency: 'JQuery-UI';
		url: #pierAddonsUrl;
		yourself! !

!PRValueLink methodsFor: '*pier-jquery' stamp: 'lr 10/7/2010 14:46'!
jqAccordionIn: aContext
	<value: 'jq-accordion' comment: 'Display children of the current structure as an accordion.'>
	
	^ self lookupStructure: aContext structure do: [ :structure | [ :html |
		html div
			script: (html jQuery new accordion);
			with: [
				(aContext enumeratorFor: structure) do: [ :child |
					html div: child menu.
					html div: [
						html rendererInstance 
							visit: child ] ] ] ] ]! !

!PRValueLink methodsFor: '*pier-jquery' stamp: 'lr 10/7/2010 14:44'!
jqDialogIn: aContext
	<value: 'jq-dialog' comment: 'Display the structure within a modal dialog.'>
	
	^ self lookupStructure: aContext structure do: [ :structure | [ :html |
		| id |
		html span
			id: (id := html nextId);
			script: (html jQuery new dialog
				html: [ :renderer | 
					html rendererInstance 
						renderer: renderer;
						visit: structure ];
				title: structure title;
				modal: true).
		html anchor
			goto: (aContext structure: structure);
			onClick: ((html jQuery id: id) dialog open return: false);
			with: (self formatDescribed: structure default: #title) ] ]! !

!PRValueLink methodsFor: '*pier-jquery' stamp: 'lr 10/7/2010 14:46'!
jqTabsIn: aContext
	<value: 'jq-tabs' comment: 'Display children of the current structure as a tabbed widget.'>
	
	^ self lookupStructure: aContext structure do: [ :structure | [ :html |
		html div
			script: (html jQuery new tabs
				selected: (self propertyAt: 'selected' ifAbsent: [ 0 ]);
				yourself);
			with: [
				html unorderedList: [
					(aContext enumeratorFor: structure) do: [ :child |
						html listItem: [
							html anchor
								url: (html jQuery ajax
									html: [ :renderer | 
										html rendererInstance 
											renderer: renderer;
											visit: child ];
									fullUrl);
								with: child menu ] ] ] ] ] ]! !
